#! /usr/bin/env python

from decorator import *
import inspect
def precondition(assertion):
	def call(fn, *args, **kw):
		regargs, varargs, varkw, defaults = inspect.getargspec(fn)		
		assert eval (assertion, dict(zip(regargs, args))), "%s assertion failure." % assertion
		return fn(*args, **kw)
	return decorator(call)
	
def postcondition(assertion):
	def call(fn, *args, **kw):
		result = fn(*args, **kw)
		assert assertion(result), "Returned value assertion failure."
		return result
	return decorator(call)

@precondition("tom > 0")
@precondition("jerry > 1")
@postcondition(lambda x: x > 1)
def foo(tom=1, jerry=2, rose=3, jack=4):
	print tom
	return jack
	
if __name__ == "__main__":
	foo()
	
	